/* Copyright (C) 2004-2005 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#ifndef __LIS_MATVEC_H__
#define __LIS_MATVEC_H__

#ifdef __cplusplus
extern "C"
{
#endif

typedef void (*LIS_MATVEC_DIA)(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
typedef void (*LIS_MATVEC_JDS)(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
typedef void (*LIS_MATVEC_CRS)(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);

	/****************************/
	/* Matrix Vector Product    */
	/****************************/
		extern void lis_matvec_ccs(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_msr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_ell(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_bsr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_1x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_1x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_1x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_1x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_2x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_2x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_2x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_2x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_3x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_3x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_3x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_3x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_4x1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_4x2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_4x3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
			extern void lis_matvec_bsr_4x4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_bsc(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_vbr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dns(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_coo(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_crs(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_ccs(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_msr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_dia(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_ell(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_jds(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_bsr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_bsc(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_vbr(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_dns(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvect_coo(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/********************************/
	/* CRS Matrix Vector Product    */
	/********************************/
		extern void lis_matvec_crs   (LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u2_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_u4_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p4_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p3s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_crs_p5s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/********************************/
	/* JDS Matrix Vector Product    */
	/********************************/
		extern void lis_matvec_jds   (LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u9(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u10(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u11(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u12(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u13(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u14(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u15(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u16(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u1s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u2s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u3s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u4s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u5s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u6s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u7s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u8s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u9s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u10s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u11s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u12s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u13s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u14s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u15s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u16s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p1(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p1s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p2s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p3s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p4s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p5s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p6s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p7s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p8s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p2ss(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u2s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u4s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u6s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_u8s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_jds_p2s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
	/********************************/
	/* DIA Matrix Vector Product    */
	/********************************/
		extern void lis_matvec_dia   (LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p3(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p4(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p5(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p6(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p7(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p8(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u1s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u2s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u3s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u4s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u5s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u6s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u7s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u8s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p1s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p2s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p3s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p4s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p5s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p6s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p7s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_p8s(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u4s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u6s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);
		extern void lis_matvec_dia_u8s_sse2(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[]);

#ifdef __cplusplus
}
#endif
#endif
