/* Copyright (C) 2004-2005 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#ifdef _OPENMP
	#include <omp.h>
#endif
#ifdef USE_MPI
	#include <mpi.h>
#endif
#include "lislib.h"

void lis_matvec_dns_u(LIS_MATRIX A, LIS_SCALAR x[], LIS_SCALAR y[])
{
	int i,j,k,is,ie,h;
	int gn,n;
	LIS_SCALAR t;
	LIS_SCALAR *yy,*xx,*vv;

	n = A->n;
	gn = A->gn;
	h  = 64;
	for(i=0;i<n;i++)
	{
		y[i] = 0;
	}
	for(k=0;k<n;k+=h)
	{
		xx = x;
		for(j=0;j<gn;j++)
		{
			is = k;
			ie = _min(n,k+h);
			yy = &y[is];
			vv = &A->value[j*n+is];
			for(i=is;i<ie;i++)
			{
				*yy += *vv * *xx;
				yy++;
				vv++;
//				y[i] += A->value[j*n+i] * x[j];
			}
			xx++;
		}
	}
}
